## ros-rolling-rmf-utils 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

project(rmf_utils VERSION 1.3.0)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

include(GNUInstallDirs)

add_library(rmf_utils INTERFACE)

target_include_directories(rmf_utils
  INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_compile_features(rmf_utils INTERFACE cxx_std_17)

# Create cmake config files
include(CMakePackageConfigHelpers)

set(INSTALL_CONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/rmf_utils/cmake")
set(PACKAGE_CONFIG_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/rmf_utils-config-version.cmake")
set(PACKAGE_CONFIG_FILE "${CMAKE_CURRENT_BINARY_DIR}/rmf_utils-config.cmake")

configure_package_config_file(
  "${CMAKE_CURRENT_LIST_DIR}/cmake/rmf_utils-config.cmake.in"
  ${PACKAGE_CONFIG_FILE}
  INSTALL_DESTINATION ${INSTALL_CONFIG_DIR}
)

write_basic_package_version_file(
  ${PACKAGE_CONFIG_VERSION_FILE}
  COMPATIBILITY ExactVersion
)

install(
  TARGETS rmf_utils
  EXPORT rmf_utils-targets
  DESTINATION lib
)

install(
  DIRECTORY include/rmf_utils
  DESTINATION include
)

install(
  FILES
    ${PACKAGE_CONFIG_VERSION_FILE}
    ${PACKAGE_CONFIG_FILE}
  DESTINATION ${INSTALL_CONFIG_DIR}
)

install(
  EXPORT rmf_utils-targets
  FILE rmf_utils-targets.cmake
  NAMESPACE rmf_utils::
  DESTINATION ${INSTALL_CONFIG_DIR}
)

export(
  EXPORT rmf_utils-targets
  FILE ${CMAKE_CURRENT_BINARY_DIR}/rmf_utils-targets.cmake
  NAMESPACE rmf_utils::
)

export(PACKAGE rmf_utils-targets)

find_package(ament_cmake_catch2 QUIET)
find_package(rmf_cmake_uncrustify QUIET)
if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND rmf_cmake_uncrustify_FOUND)
  file(GLOB_RECURSE unit_test_srcs "test/*.cpp")
  
  ament_add_catch2(
    test_rmf_utils test/main.cpp ${unit_test_srcs}
    TIMEOUT 300)
  target_link_libraries(test_rmf_utils
    rmf_utils
  )
  target_include_directories(test_rmf_utils
    PRIVATE
      $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/>
  )

  find_file(uncrustify_config_file 
    NAMES "rmf_code_style.cfg"
    PATHS "test/format/")

  rmf_uncrustify(
    ARGN include src test
    CONFIG_FILE ${uncrustify_config_file}
    MAX_LINE_LENGTH 80
  )
endif()

install(
  FILES
    test/format/rmf_code_style.cfg
  DESTINATION share/${PROJECT_NAME}
)

=== debian/changelog ===
ros-rolling-rmf-utils (1.3.0-2focal) focal; urgency=high

  * Adding missing string include for test, only shows up when building with clang (#9 <https://github.com/open-rmf/rmf_utils/issues/9>)
  * Add quality declaration documents (#1 <https://github.com/open-rmf/rmf_utils/issues/1>)
  * Changed package requirement to QUIET to allow use in non-ROS 2 packages (#6 <https://github.com/open-rmf/rmf_utils/issues/6>)
  * install rmf_code_style.cfg in rmf_utils_DIR (#4 <https://github.com/open-rmf/rmf_utils/issues/4>)
  * change to catch2 test, uncrustify everything (#3 <https://github.com/open-rmf/rmf_utils/issues/3>)
  * Contributors: Aaron Chong, Geoffrey Biggs, ddengster

 -- Grey <grey@openrobotics.org>  Sun, 19 Jan 2020 00:00:00 -0000

ros-rolling-rmf-utils (1.1.0-2focal) focal; urgency=high

  * Replace rmf_utils::optional with std::optional (#177 <https://github.com/osrf/rmf_core/issues/177>)
  * Foxy Support (#133 <https://github.com/osrf/rmf_core/issues/133>)
  * Remove ros2 dependency (#142 <https://github.com/osrf/rmf_core/issues/142>)
  * Contributors: Aaron Chong, Grey, Yadu

 -- Grey <grey@openrobotics.org>  Thu, 24 Sep 2020 00:00:00 -0000

ros-rolling-rmf-utils (1.0.0-2focal) focal; urgency=high

  * Basic utilities for use in the rmf_core packages
    
    impl_ptr - A smart pointer that helps implement a PIMPL-pattern
    
    clone_ptr - A smart pointer with cloning semantics (copying the pointer instance will clone the underlying object)
    
    optional - A stopgap measure to get the features of std::optional before C++17 is available
    
    Modular - A class for comparing integral version numbers that may wrap around due to integer overflow
  * Contributors: Grey, Luca Della Vedova, Marco A. Gutiérrez, Michael X. Grey, Morgan Quigley, Yadu, Yadunund

 -- Grey <grey@openrobotics.org>  Tue, 23 Jun 2020 00:00:00 -0000

=== debian/control ===
Source: ros-rolling-rmf-utils
Section: misc
Priority: optional
Maintainer: Grey <grey@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-rolling-ament-cmake-catch2, ros-rolling-rmf-cmake-uncrustify, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rmf-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ros-workspace
Description: Simple C++ programming utilities used by Robotics Middleware Framework packages

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rmf-utils//opt/ros/rolling/lib/:$(CURDIR)/debian/ros-rolling-rmf-utils//opt/ros/rolling/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rmf-utils 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 cmake_minimum_required(VERSION 3.5.0)
 
-project(rmf_utils VERSION 1.3.0)
+project(rmf_utils VERSION 1.4.0)
 
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD 17)
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
@@ -12,10 +12,11 @@
 
 include(GNUInstallDirs)
 
-add_library(rmf_utils INTERFACE)
+file(GLOB_RECURSE lib_srcs "src/rmf_utils/*.cpp")
+add_library(rmf_utils SHARED ${lib_srcs})
 
 target_include_directories(rmf_utils
-  INTERFACE
+  PUBLIC
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
 )
@@ -71,13 +72,11 @@
   NAMESPACE rmf_utils::
 )
 
-export(PACKAGE rmf_utils-targets)
+find_package(ament_cmake_catch2 QUIET)
+find_package(ament_cmake_uncrustify QUIET)
+if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND ament_cmake_uncrustify_FOUND)
+  file(GLOB_RECURSE unit_test_srcs "test/*.cpp")
 
-find_package(ament_cmake_catch2 QUIET)
-find_package(rmf_cmake_uncrustify QUIET)
-if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND rmf_cmake_uncrustify_FOUND)
-  file(GLOB_RECURSE unit_test_srcs "test/*.cpp")
-  
   ament_add_catch2(
     test_rmf_utils test/main.cpp ${unit_test_srcs}
     TIMEOUT 300)
@@ -89,14 +88,15 @@
       $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/>
   )
 
-  find_file(uncrustify_config_file 
+  find_file(uncrustify_config_file
     NAMES "rmf_code_style.cfg"
     PATHS "test/format/")
 
-  rmf_uncrustify(
+  ament_uncrustify(
     ARGN include src test
     CONFIG_FILE ${uncrustify_config_file}
     MAX_LINE_LENGTH 80
+    EXCLUDE include/rmf_utils/catch.hpp
   )
 endif()
 
@@ -105,3 +105,10 @@
     test/format/rmf_code_style.cfg
   DESTINATION share/${PROJECT_NAME}
 )
+
+# Export ament index path
+file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} "")
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} DESTINATION share/ament_index/resource_index/packages)
+
+file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv "prepend-non-duplicate;AMENT_PREFIX_PATH;")
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv DESTINATION share/${PROJECT_NAME}/hook)

=== debian/changelog ===
ros-rolling-rmf-utils (1.6.0-1jammy) jammy; urgency=high



 -- Grey <grey@openrobotics.org>  Wed, 07 Jun 2023 16:00:00 -0000

ros-rolling-rmf-utils (1.5.0-1jammy) jammy; urgency=high

  * Switch to rst changelogs (#28 <https://github.com/open-rmf/rmf_utils/pull/28>)
  * Reusable CI (#24 <https://github.com/open-rmf/rmf_utils/pull/24>)
  * Contributors: Esteban Martinena Guerrero, Yadunund

 -- Grey <grey@openrobotics.org>  Mon, 05 Jun 2023 16:00:00 -0000

ros-rolling-rmf-utils (1.4.0-1jammy) jammy; urgency=high

  * Add a class to help with limiting rates of events (#18 <https://github.com/open-rmf/rmf_utils/pull/18>)

 -- Grey <grey@openrobotics.org>  Sun, 13 Feb 2022 16:00:00 -0000

ros-rolling-rmf-utils (1.3.0-1jammy) jammy; urgency=high

  * Adding missing string include for test, only shows up when building with clang (#9 <https://github.com/open-rmf/rmf_utils/pull/9>)
  * Add quality declaration documents (#1 <https://github.com/open-rmf/rmf_utils/pull/1>)
  * Changed package requirement to QUIET to allow use in non-ROS 2 packages (#6 <https://github.com/open-rmf/rmf_utils/pull/6>)
  * install rmf_code_style.cfg in rmf_utils_DIR (#4 <https://github.com/open-rmf/rmf_utils/pull/4>)
  * change to catch2 test, uncrustify everything (#3 <https://github.com/open-rmf/rmf_utils/pull/3>)
  * Contributors: Aaron Chong, Geoffrey Biggs, ddengster

 -- Grey <grey@openrobotics.org>  Sat, 18 Jan 2020 16:00:00 -0000

ros-rolling-rmf-utils (1.1.0-1jammy) jammy; urgency=high

  * Replace rmf_utils::optional with std::optional (#177 <https://github.com/osrf/rmf_core/pull/177>)
  * Foxy Support (#133 <https://github.com/osrf/rmf_core/pull/133>)
  * Remove ros2 dependency (#142 <https://github.com/osrf/rmf_core/pull/142>)
  * Contributors: Aaron Chong, Grey, Yadu

 -- Grey <grey@openrobotics.org>  Wed, 23 Sep 2020 16:00:00 -0000

ros-rolling-rmf-utils (1.0.0-1jammy) jammy; urgency=high

  * Basic utilities for use in the rmf_core packages
    
    impl_ptr - A smart pointer that helps implement a PIMPL-pattern
    
    clone_ptr - A smart pointer with cloning semantics (copying the pointer instance will clone the underlying object)
    
    optional - A stopgap measure to get the features of std::optional before C++17 is available
    
    Modular - A class for comparing integral version numbers that may wrap around due to integer overflow
  * Contributors: Grey, Luca Della Vedova, Marco A. Gutiérrez, Michael X. Grey, Morgan Quigley, Yadu, Yadunund

 -- Grey <grey@openrobotics.org>  Mon, 22 Jun 2020 16:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Grey <grey@openrobotics.org>
-Build-Depends: debhelper (>= 9.0.0), cmake, ros-rolling-ament-cmake-catch2, ros-rolling-rmf-cmake-uncrustify, ros-rolling-ros-workspace
+Build-Depends: debhelper (>= 9.0.0), cmake, ros-rolling-ament-cmake-catch2 <!nocheck>, ros-rolling-ament-cmake-uncrustify <!nocheck>, ros-rolling-ros-workspace
 Homepage: 
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,12 +17,17 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
 
 # Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
 export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -31,7 +36,8 @@
 	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
